//this file is part of eMule
//Copyright (C)2005 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#include "stdafx.h"
#include "cFos.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CcFos::CcFos()
{
	pos_filter = 0;
}

CcFos::~CcFos()
{
}

bool CcFos::IsRegKey() const
{
	CRegKey mKey;
	if(mKey.Open(HKEY_LOCAL_MACHINE,_T("Software\\cFos\\cFosSpeed"),KEY_READ) == ERROR_SUCCESS)
	{
		mKey.Close();
		return true;
	}
	return false;
}

CString CcFos::GetIniFilename(CString homedir)
{
	homedir.Append(_T("\\settings.ini"));
	return homedir;
}

bool CcFos::ExeExists(CString homedir)
{
	homedir.Append(_T("\\spd.exe"));
	return ::PathFileExists(homedir)!=0;
}

CString CcFos::GetHomeDir() const
{
	CRegKey mKey;
	if(mKey.Open(HKEY_LOCAL_MACHINE,_T("Software\\cFos\\cFosSpeed"), KEY_READ) != ERROR_SUCCESS)
		return _T("");

	DWORD iIndex = 0;
	TCHAR Version[255];
	DWORD iVersionLen = 255;
	uint16 uVersion_old = 0;
	CString buffer = _T("");

	while (mKey.EnumKey(iIndex++, Version, &iVersionLen) == ERROR_SUCCESS)
	{
		uint16 uVersion = (uint16)(Version);
		if (uVersion > uVersion_old)
		{
			uVersion_old = uVersion;
			buffer = Version;
		}
	}
	if(uVersion_old == 0 || buffer.IsEmpty())
	{
		mKey.Close();
		return _T("");
	}
	
	mKey.Close(); //close old keyhandle
	if(mKey.Open(mKey, buffer, KEY_READ) == ERROR_SUCCESS)
	{
		if(mKey.QueryStringValue(_T("homedir"), Version, &iVersionLen) == ERROR_SUCCESS)
		{
			mKey.Close();
			return Version;
		}
		mKey.Close();
	}
	return _T("");
}

bool CcFos::AddIniValues(const CString &filename) const
{
	if(pos_filter == 0)
		return false;

	CStdioFile fSet;
	if(fSet.Open(filename, CFile::modeReadWrite | CFile::typeText))
	{		
		CString old_content;
		fSet.Seek(pos_filter, CFile::begin);
		CString buffer;
		while(fSet.ReadString(buffer))
			old_content.AppendFormat(_T("%s\n"), buffer);
		fSet.Seek(pos_filter, CFile::begin);
		fSet.WriteString(_T("filter=-icmp-type 0 -c lowest\n"));
		fSet.WriteString(_T("filter=-icmp-type 8 -c lowest\n"));
		fSet.WriteString(old_content);
		fSet.Close();
		return true;
	}
	return false;
}

bool CcFos::Check4IniValues(const CString& filename)
{
	bool Check4IniValues = false;
	CStdioFile fSet;	
	if(fSet.Open(filename, CFile::modeRead | CFile::typeText))
	{
		CString szLine;
		while(fSet.ReadString (szLine))
		{			
			if(szLine.Find(_T("[filters]")) > -1)
				pos_filter = fSet.GetPosition();
			else if(szLine.Find(_T("filter=-icmp-type 0 -c lowest"),0) > -1)
			{
				Check4IniValues = true;
				break;
			}
		}
		fSet.Close();
	}
	return Check4IniValues;
}

void CcFos::StartCheck()
{
	if(IsRegKey() && ExeExists(GetHomeDir()) && !Check4IniValues(GetIniFilename(GetHomeDir())))
	{
        CString strQuestion = _T("You have installed cFos!\n\nDo you want to be configured to get best results?"); 
        if (MessageBox(0, strQuestion.GetBuffer(),_T("iONiX"),MB_YESNO | MB_DEFBUTTON2) != IDYES)
			return;
		else
		{
			AddIniValues(GetIniFilename(GetHomeDir()));
			const CString buffer = GetHomeDir() + _T("\\spd.exe reboot");
			USES_CONVERSION;
			WinExec(T2A(buffer), SW_HIDE);
		}
	}
}